      Program coritd
c     Programma dimostrativo della subroutine corit    

c
c     BETA 0.1
c

      external corit
            
      integer dim
      parameter (dim=6)
      
      real lu(dim,dim),x(dim),y(dim),b(dim),tol
      integer p(dim), n,maxit,ifail,log
      double precision r(dim)
      
      character*255 fin1,fin2,fout
                                      
      log =13
      open(log,FILE='corit.log')
                                            
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE CORIT a***'
      print*
      write(*,10)'Ordine del sistema (max ',dim,')= '
      read(*,*)n   
      
      print*,'Nome del file di input (dati del sistema)= '
      read(*,'(A)')fin1
      open(11,FILE=fin1,STATUS='OLD')
      
c     leggo la matrice lu
      do 2 i=1,n
         do 1 j=1,n
            read(11,*)lu(i,j)
            write(log,*)lu(i,j)
    1    continue
    2 continue
    
c     leggo il vettore delle permutazioni
      read(11,*)
      do 3 i=1,n
         read(11,*)p(i)
         write(log,*)p(i)
    3 continue                             
    
c     leggo il vettore dei termini noti    
      write(log,*)'termine noto'
      read(11,*)
      do 4 i=1,n
         read(11,*)b(i) 
         write(log,*)b(i)
    4 continue
      close(11)
      
c     leggo la prima soluzione data al sistema, da approssimare alla reale      
      print*,'Nome del file di input (soluzione del sistema)= '
      read(*,'(A)')fin2
      open(12,FILE=fin2,STATUS='OLD')
      write(log,*)'soluzione iniziale'
      do 5 i=1,n
         read(12,*)x(i) 
         write(log,*)x(i)
    5 continue
      close(12)
      
      print*,'Tolleranza relativa= '
      read(*,*)tol
      
      print*,'Numero massimo di iterazioni= '
      read(*,*)maxit
            
      write(log,*)' chiamata corit'
      
      call corit(lu,p,b,x,y,dim,n,tol,maxit,r,ifail,log)
      
      write(log,*)' uscita corit, ifail= ',ifail
      
      if (ifail .eq. 0) print*,'Nessun errore!' 
      if (ifail .eq. 1) stop 'Errore! tolleranza relativa non valida'
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
      if (ifail .eq. 8) stop 'Errore! numero di iterazioni non valido'
      if (ifail .eq. 9) print*,'Attenzione! raggiungimento del numero',
     %                         ' massimo di iterazioni'
      
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(13,FILE=fout)
      write(13,20)(x(i),i=1,n)
      write(13,*)
      write(13,20)(r(i),i=1,n)
      close(13)
      
      print*,'Soluzione corretta= '
      write(*,20)(x(i),i=1,n)
      
      print*,'Residuo del sistema= '
      write(*,20)(r(i),i=1,n)
      
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
   30 format (1X,I3)
   
      end
                                     