      Subroutine fft2(flag,f,n,ifail)
c
c  SCOPO:calcolo della trasformata discreta di Fourier "radix 2"
c        o della sua inversa.
c        
c  PARAMETRI DI INPUT:  
c 
c  - flag,              booleano,  indicatore DFT/IDFT
c  -    f,  vettore di complessi,  vettore da trasformare
c  -    n,                intero,  ordine della trasformata
c   
c  PARAMETRI DI OUTPUT:
c
c  -     f,  vettore di complessi,  componenti della trasformata
c  - ifail,                intero,  indicatore d'errore
c   
c  ROUTINES RICHIAMATE:
c
c  - btrev
c            
       integer btrev
       external btrev
       
       real twopi
       parameter (twopi=6.283185308)
       
       logical flag
       integer n,ifail
       complex f(0:n-1)
       
       integer d,nesp,ind1,ind2,s,z,st
       real esp
       complex e,t
       
c  Controllo dell'ordine
       if (n .le. 0) then
          ifail=20
          goto 999
       endif
             
c  Controllo che n sia potenza di due
       k=n
       m=0
   10  if (mod(k,2) .ne. 0) goto 20
          m=m+1
          k=k/2
       goto 10
   20  continue    
       
       if (k .ne. 1) then
          ifail=21
          goto 999
       endif

c  DFT/IDFT
       if (flag) then 
          st=-1 
       else 
          st=1
       endif
       
       d=n
c  Numero di esponenziali diversi al primo passo
       nesp=1
                        
       do 50 k=1,m       
c    Distanza tra i nodi duali al passo k  
          d=d/2
          s=0
          do 40 i=1,nesp        
c      Calcolo dell'esponenziale     
             z=s
             z=isha(z,-(m-k))
             z=btrev(z,k)
             esp=st*twopi*z/2**k
             e=exp(cmplx(0,esp))
             do 30 l=0,d-1
c        Posizione del primo elemento della coppia duale
                ind1=l+s
c        Posizione del secondo elemento della coppia duale
                ind2=ind1+d
c        Calcolo di una DFT di ordine 2        
                t=e*f(ind2)
                f(ind2)=f(ind1)-t
                f(ind1)=f(ind1)+t 
   30        continue
             s=s+2*d
   40     continue
c      Numero di esponenziali diversi al passo k+1    
          nesp=nesp*2
   50  continue
                                                  
c  Ordinamento del vettore f
       do 60 k=1,n-2
          i=btrev(k,m)
          if (i .gt. k) then
             t=f(k)
             f(k)=f(i)
             f(i)=t
          endif
   60  continue
       
c  N.B.: se si esegue la IDFT il vettore f viene diviso per n      
       if (.not. flag) then
          do 70 i=0,n-1
             f(i)=f(i)/n
   70     continue          
       endif
                                                             
       ifail=0
                                                             
  999  continue

      End
      stop