      Subroutine fsbpk (l,b,n,ifail)
c
c  SCOPO: risoluzione di un sistema lineare L*x=b, con matrice dei 
c         coefficienti L di tipo triangolare inferiore.
c 
c  PARAMETRI DI INPUT:  
c 
c  - l,  vettore di reali,  coefficienti non nulli
c  - b,  vettore di reali,  termini noti
c  - n,            intero,  ordine del sistema
c 
c  PARAMETRI DI OUTPUT:
c
c  -     b,  vettore di reali,  soluzione del sistema
c  - ifail,  intero          ,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna
c
       integer n,ifail
       real l(n*(n+1)/2),b(n)             
      
c     Controllo della dimensione
       if (n .le. 0) then 
          ifail=3
          goto 999
       endif
       
c     Controlla della singolarit
       id=0
       do 10 i=1,n                           
          id=id+i
          if (l(id).eq.0) then
             ifail=4
             goto 999
          endif
   10  continue

c     Forward Substitution
       il=0
       do 30 i=1,n
          do 20 j=1,i-1     
             il=il+1
             b(i)=b(i)-l(il)*b(j)
   20     continue
          il=il+1
          b(i)=b(i)/l(il)
   30  continue       

       ifail=0  
       
  999  continue
  
	End   
	stop    