      Subroutine lut(d,e,f,n,ifail)
c
c  SCOPO: fattorizzazione di una matrice quadrata tridiagonale A
c         nella forma A=L*U, dove L  una matrice bidiagonale in-
c         feriore a diagonale unitaria e U bidiagonale superiore.
c
c  PARAMETRI DI INPUT:
c                      
c  - d,  vettore di reali,  diagonale principale 
c                           della matrice da fattorizzare
c  - e,  vettore di reali,  diagonale inferiore 
c                           della matrice da fattorizzare
c  - f,  vettore di reali,  diagonale superiore 
c                           della matrice da fattorizzare
c  - n,            intero,  ordine della matrice
c
c  PARAMETRI DI OUTPUT:
c
c  -     d,  vettore di reali,  diagonale principale
c                               della matrice fattorizzata
c  -     e,  vettore di reali,  diagonale inferiore
c                               della matrice da fattorizzata
c  -     f,  vettore di reali,  diagonale superiore
c                               della matrice da fattorizzata
c  - ifail,            intero,  indicatore di errore
c
c  ROUTINE RICHIAMATE:
c
c  -nessuna
c
       integer n,ifail
       real d(n),e(n-1),f(n-1)
      
c  Controllo della dimensione 
       if (n .le. 0) then
          ifail=3
          goto 999
       endif          
                          
c  Fattorizzazione
       do 10 k=1,n-1

c     Controllo della singolarit di un minore principale
          if (d(k) .eq. 0) then
             ifail=6
             goto 999
          endif                                        
c     Calcolo di un elemento della diagonale principale          
          e(k)=e(k)/d(k)                              
c     Calcolo di un elemento della diagonale inferiore
          d(k+1)=d(k+1)-e(k)*f(k)
   10  continue   
                 
       ifail=0
       
  999  continue

      End 
	stop     