      Subroutine nwt(p,a,n,x,m,y,ifail)
c
c  SCOPO:Calcolo del valore di un polinomio in un punto.
c        
c  PARAMETRI DI INPUT:  
c 
c  - p,  vettore di reali,  ascisse dei punti di interpolazione
c  - a,  vettore di reali,  coefficienti del polinomio interpolante
c  - n,            intero,  numero di punti di interpolazione
c  - x,  vettore di reali,  punti in cui valutare il polinomio
c  - m,            intero,  numero di punti in cui valutare il polinomio
c 
c  PARAMETRI DI OUTPUT:
c
c  -     y, vettore di reali, valori calcolati
c  - ifail,           intero, indicatore d'errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna
c
       integer n,m,ifail
       real p(n),a(n),x(m),y(m)
       
c      Controllo sul numero di punti
       if (n .le. 0  .or.  m .le. 0) then
           ifail=11
           goto 999
        endif
       
       do 10 i=1,m
          y(i)=a(1)
          do 10 j=2,n
             y(i)=y(i)*(x(i)-p(j))+a(j)
   10     continue
   20  continue
      
  999  continue         
       
	End
        stop