      Subroutine slup(lu,p,b,ldlu,n,ifail,log)
c
c  SCOPO: risoluzione di un sistema lineare A*x=b mediante la ri-
c         soluzione del sistema equivalente (L*U)*x=P*b, dove P 
c          una matrice di permutazione ed L*U  la fattorizza-
c         zione di P*A.
c 
c  PARAMETRI DI INPUT:  
c 
c  -   lu,   matrice di reali,  permutate le righe secondo p
c                               restituisce i fattori L ed U 
c  -    p,  vettore di interi,  indici delle righe di a da 
c                               permutare per ottenere L ed U   
c  -    b,   vettore di reali,  termini noti
c  - ldlu,             intero,  leading dimension di lu dichia-
c                               rata nel programma chiamante
c  -    n,             intero,  ordine del sistema 
c
c  PARAMETRI DI OUTPUT:
c
c  -     b,  vettore di reali,  soluzione del sistema
c  - ifail,            intero,  indicatore di errore
c   
c  ROUTINES RICHIAMATE:
c
c  - nessuna.
c
       integer ldlu,n,p(n),ifail
       real lu(ldlu,n),b(n),somma
      
c     Controllo della dimensione
       if (n .le. 0  .or.  n .gt. ldlu) then
         ifail=3
         goto 999
       endif                   
                           
c     Controllo della singolarit
       do i=1,n
          if (lu(p(i),i) .eq. 0) then
             ifail=4
             goto 999
          endif            
       end do
       
       write(log,*)'b(i)=',(b(i),i=1,n)
       
       do i=1,n
          do j=1,n
              write(log,*)lu(p(i),j)
          end do
       end do
       
       write(log,*)'Ly=Pb'
c      Risoluzione di L*y=P*b (con y=U*x)
       
       write(log,*)'b(1)= ',b(1)
       do 10 j=1,n
          write(log,*)'j=',j 
          do 5 i=j+1,n              
             b(i)=b(i)-lu(p(i),j)*b(j)  
             write(log,*)'i=',i,' p(i)=',p(i),' b(i)=',b(i) 
    5     continue
   10  continue

       write(log,*)'Ux=y'              
c     Risoluzione di U*x=y 
       do 20 j=n,1,-1
          write(log,*)'j=',j
          b(j)=b(j)/lu(p(j),j)
          do 15 i=j-1,1,-1             
             b(i)=b(i)-lu(p(i),j)*b(j) 
             write(log,*)'i=',i,' p(i)=',p(i),' b(i)=',b(i)
   15     continue
   20  continue
          write(log,*)'b(5)=',b(5)

       ifail=0
  
  999  continue
      
      end